/*********************************************************************
 * Clase de Utilidad: GUIElement (Botones del interfaz de usuario)
 * Programación Multimedia y Juegos
 * Autor: David Vallejo Fernández    david.vallejo@tegnix.com
 * Autor: Carlos González Morcillo   carlos.gonzalez@tegnix.com
 *
 * You can redistribute and/or modify this file under the terms of the
 * GNU General Public License ad published by the Free Software
 * Foundation, either version 3 of the License, or (at your option)
 * and later version. See <http://www.gnu.org/licenses/>.
 *
 * This file is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.  
 *********************************************************************/

package util;

import nme.Assets;
import aze.display.TileSprite;
import aze.display.TileLayer;
import nme.geom.Rectangle;

class GUIElement extends TileSprite {
  private var _root:TileLayer;   // Capa de dibujado del elemento
  public var _id:String;                // Identificador del elemento
  public var _active:Bool;              // Está activo el elemento del gui?
  public var _blink:Bool;               // Parpadea?
  public var _area:Rectangle;           // Rectangle para detectar si click

  // Constructor =====================================================
  public function new(layer:TileLayer, id:String, x:Int, y:Int, 
		      act:Bool=false):Void {
    super(layer, id);
    _root = layer; _root.addChild(this);  _id = id;
    this.x = x;  this.y = y;
    _active = act; _blink = false;
    _area = new Rectangle(x - width/2, y - height/2, width, height);
    update();
  }

  // Métodos auxiliares ==============================================
  public function isClicked(xp:Float, yp:Float):Bool {
    return _area.contains(xp,yp);  }

  public function getId():String { return _id; }

  // update ==========================================================  
  public function update(time:Float=0):Void {
    if (_active) alpha = 1.0; else alpha = 0.5;
    if (_blink) alpha = 0.5 + Math.abs(Math.sin(time*0.005))*0.5;
  }
}